function div(x,y) { return Math.floor(x/y); }
var i8 = [0,1,2,3,4,5,6,7];

var l=18;

var n=16, m=24;
var ind=[];
for (var i=0; i<n; i++) {
    for (var j=0; j<m; j++) {
        var r = [i,j]; r.i = m*i+j;
        ind.push(r);
    }
}

function getcolor(i) {
    var skew = i[1]/m - i[0]/(4*n);
    return d3.lab(40+i[1]*40/m, 40-skew*50, -50+i[0]*70/n);
}

var svg_all = d3.select("#svg")
    .append("g").attr("transform", "scale(2)translate(5,10)");
var svg  = svg_all.append("g"),
    fore = svg_all.append("g");

var rects = [0,1].map(function() {
    var r = svg.append("g")
        .selectAll("rect").data(ind).enter().append("g")
        .attr("transform", ([y,x])=>"translate("+l*x+","+l*y+")");
    r.append("rect").attr({x:0, y:0, width:l, height:l, fill:getcolor});
    r.append("text")
        .attr({x:5, y:14, "font-size":14, opacity:0.8})
        .text(i => (i.i%5)%2 == div(i.i,3)%2 ? 1 : 0);
    return r;
})[1];

function fade(obj, del, dur, opacity) {
    return obj.transition().delay(del).duration(dur).ease("linear")
        .style("opacity", opacity);
}

function addrule(lines) {
    var rule = fore.selectAll("rule")
        .data(lines)
        .enter().append("line")
        .attr({
            stroke:"black", "stroke-width": 4,//n => 2*(1 + (n%16==0)),
            x1: p=>p[0], y1: p=>p[1], x2: p=>p[2], y2: p=>p[3]
        })
        .style("opacity", 0);
    fade(rule, 0, 1200, 1);
    rule.transition().delay(1200).duration(400).ease("linear")
        .attr("stroke-width", 2);
}
var lines = ([0,8,16,24].map(x => [l*x,-1,l*x,1+n*l])).concat
            ([0,8,16]   .map(y => [-1,l*y,1+m*l,l*y]));
function divide() { addrule(lines); }

var off = m*l + 40;
function dest() {
    addrule(lines.map(([a,b,c,d])=>[off+b,a,off+d,c]));
}

var mat;
function fadeback() {
    mat = rects.filter(([y,x]) => div(y,8)==0 && div(x,8)==0);
    mat.each(function() {svg_all.node().appendChild(this);})
    fade(svg,  0, 1000, 0.4);
    fade(fore, 0, 1000, 0.4);
}

function popout() {
    mat.transition().duration(1800)
        .attr("transform", ([y,x])=>
              "scale(1.5)translate("+(off/2-30+l*x)+","+(70+l*y)+")");
}

function transpose() {
    mat.transition().duration(2500)
        .delay(([y,x]) => 30*y+100*x)
        .attr("transform", ([y,x])=>
              "scale(1.5)translate("+(off/2-30+l*y)+","+(70+l*x)+")");
}

function insert() {
    mat.transition().duration(1500)
        .attr("transform", ([y,x])=>"translate("+(off+l*y)+","+l*x+")");
    fade(svg,  600, 1000, 1);
    fade(fore, 600, 1000, 1);
    setTimeout(function() {mat.each(function(){
        svg.node().appendChild(this);
    });}, 1650);
}

function transpose8x8(i,j) {
    var mat = rects.filter(([y,x]) => div(y,8)==i && div(x,8)==j);
    mat.each(function() {svg_all.node().appendChild(this);})
        .transition().duration(1500)
        .attr("transform", ([y,x])=>"translate("+(off+l*y)+","+l*x+")");
    setTimeout(function() {mat.each(function(){
        svg.node().appendChild(this);
    });}, 1500);
}

var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0: divide(); break;
        case 1: dest(); break;
        case 2: fadeback(); break;
        case 3: popout(); break;
        case 4: transpose(); break;
        case 5: insert(); break;
        case 6: transpose8x8(1,0); break;
        case 7: transpose8x8(0,1); break;
        case 8: transpose8x8(1,1); break;
        case 9: transpose8x8(0,2); break;
        case 10: transpose8x8(1,2); break;
    }
}
