function div(x,y) { return Math.floor(x/y); }

var pos=[];
for (var i=0; i<64; i++) {
    var p = pos[i] = {p:i, xv:i%16, yv:Math.floor(i/16)};
    p.x = p.xv - [0,6,4,2][p.yv];
    p.y = 2*p.yv;
    p.i = 0<=p.x && p.x<8 ? 8*p.y + p.x : -1;
}
function copypos(p) {
    return { p:p.p,xv:p.xv,yv:p.yv,x:p.x,y:p.y,i:p.i };
}
var pos_valid = pos.filter(function(p) { return p.i>=0; });

var roff = 121;
function gettrans(p) { return "translate("+(roff+20*p.xv)+","+20*(1+p.yv)+")"; }
var lbitw = 8;
function getxfromp(p) { return 20 + lbitw*p; }
function getx(p) { return getxfromp(p.p); }
function color(i) { return i.i<0 ? "white" : d3.interpolateYlGnBu(0.9-i.i/90); }
function darkenIf(c, i) { return i ? c : d3.rgb(c).darker(0.5); }

var bliny_init = 130,
    bliny = bliny_init;

var svg_all = d3.select("#svg").append("g")
    .attr("transform", "scale(2)");
var back = svg_all.append("g"),
    svg  = svg_all.append("g"),
    fore = svg_all.append("g");
back.selectAll("rule")
    .data([0,8,16,24,32,40,48,56,64])
    .enter().append("line")
    .attr("stroke", "grey")
    .attr("stroke-width", function(n) { return 1 + (n%16==0); })
    .attr({x1: getxfromp, y1: bliny-5, x2: getxfromp, y2: bliny+152});
function sel(i) { return function(l) { return l[i]; }; }
var fadeGradient = fore.append("defs").append("linearGradient")
    .attr({id: "fadeGradient"});
fadeGradient.append("stop").attr({class:"fade0", offset:"0%"});
fadeGradient.append("stop").attr({class:"fade1", offset:"100%"});
fore.selectAll("faderect")
    .data([[0,bliny-10,roff], [bliny-10,162,19]])
    .enter().append("rect")
    .attr({x:0, y:sel(0), width:sel(2), height:sel(1), "class":"fadeRect"});

var brec = svg.selectAll("bit").data(pos)
    .enter().append("g")
    .attr("transform", gettrans);
var blin = svg.selectAll("bit")
    .data(pos_valid)
    .enter().append("rect")
    .attr({x:getx, y:bliny, width:lbitw, height:lbitw})
    .attr("fill", color);

brec.append("rect")
    .attr({x:0, y:0, width:20, height:20})
    .attr("fill", color);
brec.append("text")
    .attr({x:4, y:18, "font-size":"20", opacity:"70%"})
    .text(function(i) { return i.i<0 ? "-" : (i.i%5)%2 == div(i.i,3)%2 ? 1 : 0; });

var blincopies = [];
function copyblin() {
    return svg.selectAll("bit")
        .data(pos_valid)
        .enter().append("rect")
        .attr({x:getx, y:bliny, width:lbitw, height:lbitw})
        .attr("fill", color)
}
function getFilter(mask) { return function(p) { return mask[p.yv]; }; }
function shift_magic(i) {
    var droptime = 1000,
        dur = 1200;
    var f = getFilter(masks[i]),
        shift = shifts[i];
    blincopies.push(blin); blin = copyblin();
    brec.filter(f)
        .transition().delay(droptime).duration(dur)
        .attr("transform", function(p) { p.xv-=shift; return gettrans(p); });
    bliny += 70;
    blin.transition().duration(droptime).attr("y", bliny);
    blin.filter(f)
        .each(function() {this.parentNode.appendChild(this);})
        .transition().delay(droptime).duration(dur)
        .attr("x", function (p) { p.p -= shift; return getx(p); });
}

function reset() {
    blincopies.push(blin);
    [blincopies[1],blincopies[2]].map(function(brec) {
        brec.style("opacity", 1)
            .transition().duration(700).ease("linear")
            .style("opacity", 0.3);
    });
    for (var i=0; i<64; i++) { var p=pos[i]; p.xv=i%16; p.p=i; }
    brec.filter(p=>p.i>=8).transition().duration(700).ease("linear")
        .style("opacity", 0.7);
    brec.filter(p=>p.i<0||p.i>=8).transition().duration(1000).ease("linear")
        .style("opacity", 0.25);
    //  .attr("transform", gettrans);
    bliny = bliny_init;
}

var maskboxes, bshf;
function shift_drag(i) {
    var droptime = 600,
        dur = 800;
    bshf = copyblin();
    bshf.transition().duration(droptime).attr("y", bliny+26);
    bshf.transition().delay(droptime).duration(dur)
        .attr("x", function (p) { return getxfromp(p.p - shifts[i]); });
}
function shift_mask(i) {
    maskboxes = back.selectAll("mask")
        .data(masks[i])
        .enter().append("rect")
        .attr({
            x: function(m,i) { return getxfromp(16*i); },
            y: function(m) { return bliny-6 + 26*m; },
            width: 16*lbitw,
            height: 20,
            color: "black"
        })
        .style("opacity", 0);
    maskboxes.transition().duration(500).ease("linear")
        .style("opacity", 0.3);
}
function shift_mix(i) {
    var dur = 1000;
    var mask = masks[i];
    blin = copyblin();
    bliny += 70;
    pos_valid=[]; function pushpos(p) { pos_valid.push(copypos(p)); }
    blin.filter(function(p) { return p.p>=0 && !mask[div(p.p, 16)]; })
        .each(pushpos);
    bshf.filter(function(p) { var x=(p.p-=shifts[i]); return x>=0 && mask[div(x, 16)]; })
        .each(pushpos);
    blin = svg.selectAll("bit")
        .data(pos_valid)
        .enter().append("rect")
        .attr({
            x:getx, width:lbitw, height:lbitw, fill:color,
            y:function(p) {return bliny-70+26*mask[div(p.p, 16)];},
        });
    blin.transition().duration(dur).attr("y", bliny);
    blincopies[i+1].transition().delay(dur).remove();
    brec.filter(p => p.i>=0 && (p.yv==2||i==1))
        .transition().delay(dur).duration(400).ease("linear")
        .style("opacity", 1);
    maskboxes.transition().delay(dur-100).duration(400).ease("linear")
        .style("opacity", 0.1);
}

function final_mask() {
    maskboxes = back.selectAll("mask")
        .data([0,1,2,3])
        .enter().append("rect")
        .attr({
            x: function(i) { return getxfromp(16*i); },
            y: bliny-6,
            width: 8*lbitw,
            height: 20,
            color: "black"
        })
        .style("opacity", 0);
    maskboxes.transition().duration(400).ease("linear")
        .style("opacity", 0.3);
    blin.filter(function(p) { return p.p%16 >= 8; })
        .style("opacity", 1)
        .transition().delay(500).duration(600).ease("linear")
        .style("opacity", 0);
    maskboxes.transition().delay(1200).duration(400).ease("linear")
        .style("opacity", 0.08);
    brec.filter(p=>p.i<0).transition().delay(400).duration(800).ease("linear")
        .style("opacity", 0);
    roff = 116;
//  brec.transition().delay(1300).duration(1000)
//      .attr("transform", p => gettrans({xv:4+p.xv-(3*p.y)%8, yv:p.yv}));
}


var masks = [[0,1,1,0], [0,1,0,1]];
var shifts = [4, 2];
var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0: shift_magic(0); break;
        case 1: shift_magic(1); break;
        case 2: reset(); break;
        case 3: shift_drag(0); break;
        case 4: shift_mask(0); break;
        case 5: shift_mix (0); break;
        case 6: shift_drag(1); break;
        case 7: shift_mask(1); break;
        case 8: shift_mix (1); break;
        case 9: final_mask(); break;
    }
}
