var y = d3.scale.log()
    .domain([0.446583, 51200])


    .range([384, 3]);

var yAxis = d3.svg.axis()
    .scale(y)
    .orient("right")
    .ticks(0, n=>n<1e3 ? n : n.toExponential().replace("+",""))
    .tickValues([1,10,100,1000,1e3,1e4])
    .outerTickSize(0);

var svg = d3.select("#svg").append("g")
    .attr("transform", "scale(2)translate(-3.5,0)");
svg.append("g")
    .attr("class", "y axis")
    .call(yAxis);
svg.append("text")
    .attr({"transform":"rotate(-90)", x:-200, y:33, dy:"1em"})
    .style({"text-anchor":"middle", "font-size":"16px"})
    .text("Speed (MB/s)");

d3.select("#topbar")
    .selectAll("text").data(["15.0", "16.0"]).enter()
    .append("text")
    .attr({x:(_,i)=>390+808*i, y:34})
    .style({"text-anchor":"middle", "font-size":"40px"})
    .text(t=>t);

var widths = [];
for (var i=0; i<32; i++) widths[i] = 30 + 48*i + 40*(i>=16);

d3.select("#bottombar")
    .selectAll("text").data(widths).enter()
    .append("text")
    .attr({x:x=>x, y:24})
    .style({"text-anchor":"middle", "font-size":"24px",
            "letter-spacing":(d,i)=>i%16==15?"-3px":i%16>=10?"-2px":0})
    .text((_,i)=>Math.ceil(Math.pow(1.6,i%16)));
