function div(x,y) { return Math.floor(x/y); }

var pos=[];
for (var i=0; i<8; i++) {
    var row = pos[i] = [];
    for (var j=0; j<16; j++) {
        var x = j - (3*i)%8,
            pi = 0<=x&&x<8 ? 8*i+x : -1;
        row[j] = {yv:i, xv:j, x:x, i:pi};
    }
}

function translate(a,b) { return "translate("+a+","+b+")"; }
function color(i) { return i.i<0 ? "#ffffff00" : d3.interpolateYlGnBu(0.9-i.i/90); }

var bliny_init = 130,
    bliny = bliny_init;

var svg_all = d3.select("#svg")
    .append("g").attr("transform", "scale(2)");
var back = svg_all.append("g"),
    svg  = svg_all.append("g"),
    fore = svg_all.append("g");

var rows = svg.selectAll("row")
    .data(pos)
    .enter().append("g")
    .attr("transform", (p,i) => translate(302,20*i));
var brec = rows.selectAll("bit")
    .data(x=>x)
    .enter().append("g")
    .attr("transform", (p,i) => translate(20*i,0));

brec.append("rect")
    .attr({x:0, y:0, width:20, height:20})
    .attr("fill", color);
brec.append("text")
    .attr({x:4, y:18, "font-size":"20", opacity:"70%"})
    .text(i => i.i<0 ? "-" : (i.i%5)%2 == div(i.i,3)%2 ? 1 : 0);


function fade(obj, del, dur, opacity) {
    return obj.transition().delay(del).duration(dur).ease("linear")
        .style("opacity", opacity);
}

function split() {
    rows.transition().duration(2000)
        .attr("transform", (p,i) =>
            "scale(0.7)" +
            translate(20+20*16*div(i,2), 60+100*(i%2))
        );
}

function select() {
    fade(brec.filter(p=>p.i==-1), 0, 500, 0).remove();
}

function shift() {
    brec.transition().duration(1600)
        .attr("transform", p => translate(20*(p.x+8*(p.yv%2)),0));
}

function merge() {
    rows.transition().duration(1000)
        .attr("transform", (p,i) =>
            "scale(0.7)" +
            translate(20+20*16*div(i,2), 110)
        );
}

function wrap() {
    rows.transition().duration(2000)
        .attr("transform", (p,i) => translate(382-8*20*(i%2),20*i));
}

var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0: split(); break;
        case 1: select(); break;
        case 2: shift(); break;
        case 3: merge(); break;
        case 4: wrap(); break;
    }
}
