function div(x,y) { return Math.floor(x/y); }
var i8 = [0,1,2,3,4,5,6,7];

var l=23,
    pad=50;

var n=13, m=27;
var ind=[];
for (var i=0; i<n; i++) {
    var row = ind[i] = [];
    for (var j=0; j<m; j++) {
        row[j] = [i,j];
        row[j].i = m*i+j;
    }
}

function getcolor(i) {
    var skew = i[1]/m - i[0]/(4*n);
    return d3.lab(40+i[1]*40/m, 40-skew*50, -50+i[0]*70/n);
}

var svg_all = d3.select("#svg")
    .append("g").attr("transform", "scale(2)translate("+pad+", "+pad+")");
var fore = svg_all.append("g"),
    svg  = fore.append("g");

var fadeGradient = fore.append("defs").append("linearGradient")
    .attr({id: "fadeGradient"});
fadeGradient.append("stop").attr({class:"fade1", offset:"0%"});
fadeGradient.append("stop").attr({class:"fade0", offset:"70%"});
fadeGradient.append("stop").attr({class:"fade0", offset:"100%"});
fore.append("rect")
    .attr({x:l*(m+7)+1, y:-10, width:l*7, height:20+n*(l+1), "class":"fadeRect"});
var fadeGradient2 = fore.append("defs").append("linearGradient")
    .attr({id: "fadeGradient2"});
fadeGradient2.append("stop").attr({class:"fade0", offset:"0%"});
fadeGradient2.append("stop").attr({class:"fade1", offset:"100%"});
fore.append("rect")
    .attr({x:-pad, y:-10, width:pad-1, height:20+n*(l+1), "class":"fadeRect2"});
var fadeGradient3 = svg_all.append("defs").append("linearGradient")
    .attr({id: "fadeGradient3", x1:0, x2:0, y1:0, y2:1});
fadeGradient3.append("stop").attr({class:"fade1", offset:"0%"});
fadeGradient3.append("stop").attr({class:"fade0", offset:"80%"});
fadeGradient3.append("stop").attr({class:"fade0", offset:"100%"});
svg_all.append("rect")
    .attr({x:-pad, y:11.5*(l+1), width:2*pad+l*(m+14)+1, height:(n-11)*(l+1), "class":"fadeRect3"});

var rows = svg.selectAll("row").data(ind)
    .enter().append("g")
    .attr("transform", (i,y) => "translate(0,"+(l+1)*y+")");
function addrects(r) {
    r.append("rect").attr({x:0, y:0, width:l, height:l, fill:getcolor});
    r.append("text")
        .attr({x:6, y:18, "font-size":16, opacity:0.8})
        .text(i => (i.i%5)%2 == div(i.i,3)%2 ? 1 : 0);
}
var rects = rows.selectAll("rect").data(x=>x)
    .enter().append("g").attr("transform", i=>"translate("+l*i[1]+", 0)");
addrects(rects);
var boundary = rows.selectAll("boundary")
    .data(r => r.filter(x => x.i%8 == 0))
    .enter().append("line")
    .attr({x1:i=>l*i[1], y1:0, x2:i=>l*i[1], y2:l})
    .attr({stroke:"black", "stroke-width":3})
    .style("opacity", 0);

function fade(obj, del, dur, opacity) {
    return obj.transition().delay(del).duration(dur).ease("linear")
        .style("opacity", opacity);
}

function addboundary() { fade(boundary, 0, 600, 1); }
var rule;
function align() {
    rows.transition().duration(900)
        .attr("transform", (i,y) => "translate("+(l*((m*y)%8))+","+(l+1)*y+")");
    rule = fore.selectAll("rule")
        .data([0,8,16,24,32])
        .enter().append("line")
        .attr({
            stroke:"black", "stroke-width": 4,//n => 2*(1 + (n%16==0)),
            x1: x=>l*x, y1: -10, x2: x=>l*x, y2: 10+n*(l+1)
        })
        .style("opacity", 0);
    fade(rule, 1600, 900, 1);
    boundary.transition().delay(2500).remove();
    fade(rule, 2600, 800, 0.6)
        .attr("stroke-width", n => 2 + (n%16==0));
}

function wrap() {
    ind.forEach(r=>r.forEach(function (i) {
        var y=i[0], x=i[1];
        i.wx = x>16 ? l*(x-m+(m*(y+1))%8)-1
                    : l*(x+m+(m*(y-1))%8)+1;
        i.wy = y + (x>16?1:-1);
    }));
    var wrap = svg.selectAll("wrap")
        .data(ind.reduce((a,b) => a.concat(b))
                 .filter(i => i.wy>=0 && i.wy<n && i.wx<l*(m+14)))
        .enter().append("rect")
        .attr({x: i=>i.wx, y: i=>(l+1)*i.wy, width:l, height:l,
               fill:getcolor})
        .style("opacity", 0);
    fade(wrap,    0, 800, 0.8);
    fade(wrap, 2500, 600, 0.3);
}

var front, frontrows, frects, highlightbox, maskback, maskbox;
function highlight() {
    front = svg_all.append("g");
    frontrows = front.selectAll("row").data(i8)
        .enter().append("g")
        .attr("transform", y => "translate("+(l*((m*y)%8))+","+(l+1)*y+")");
    frects = frontrows.selectAll("rect")
        .data(i => ind[i].slice(0,8))
        .enter().append("g").attr("transform", i=>"translate("+l*i[1]+", 0)");
    addrects(frects);
    highlightbox = front.selectAll("highlight").data(i8)
        .enter().append("rect")
        .attr({
            x:y=>l*((m*y)%8), y:y=>(l+1)*y, height:l, width:8*l,
            fill:"none", stroke:"black" //, id:i=>"highlight"+i
        });

    var mask = svg_all.append("mask")
        .attr({"id":"mask", x:-pad, y:-pad,
               width:2*pad+l*(m+14), height:2*pad+n*(l+1)});
    maskback = mask.append("rect")
        .attr({x:-pad, y:-pad, width:2*pad+l*(m+14), height:2*pad+n*(l+1), fill:"white"})
        .style("opacity", 1);
//  mask.selectAll("highlight").data(i8)
//      .enter().append("use")
//      .attr({fill: "white", opacity: 1})
//      .attr("xlink:href", i=>"#highlight"+i);
    maskbox = mask.selectAll("highlight").data(i8)
        .enter().append("rect")
        .attr({x:y=>l*((m*y)%8), y:y=>(l+1)*y, height:l, width:8*l,
               fill:"white"})
        .style("opacity", 0);

    svg.attr("mask", "url(#mask)");
    fade(maskback, 0, 1000, 0.4);
    fade(rule, 0, 1000, 0.24);
}

function dealign() {
    fade(highlightbox, 0, 200, 0);
    frontrows.transition().duration(2200)
        .attr("transform", y => "translate("+l*12.5+","+l*(y+1.5)+")");
}

function transpose() {
    frects.transition().duration(600)
        .delay(([y,x]) => 8*y+30*x)
        .attr("transform", i=>"translate("+l*i[0]+", "+l*(i[1]-i[0])+")");
}

function back() {
    fade(frects, 0, 800, 0).remove();
    [highlightbox,maskbox].map(b=>fade(b, 300, 1000, 1));
}

var colind = 0;
function nextcol() {
    colind += 8;
    [highlightbox,maskbox].map(
        h=>h.transition().ease("sin").duration(600)
            .attr({x: y=>l*(colind+(m*y)%8)})
    );
}

function back2() {
    fade(highlightbox, 0, 300, 0);
    fade(maskback,     0, 400, 1);
    fade(rule,         0, 400, 0.6);

    maskbox.transition().delay(400).duration(0).attr({x: y=>l*((m*y)%8)});
    fade(maskback, 1000, 800, 0.4);
}

function box16() {
    fade(highlightbox.attr({x:0, width:16*l}), 0, 600, 1);
    colind = 0;
    hbnext = front.selectAll("highlight").data(i8)
        .enter().append("rect")
        .attr({
            x:l*(colind+8), y:y=>(l+1)*y, height:l, width:16*l,
            fill:"none", stroke:"black"
        })
        .style("opacity", 0);
}

function nextcol16() {
    colind += 8;
    fade(hbnext,         0, 600, 1);
    fade(highlightbox, 400, 400, 0);
    highlightbox.transition().delay(800).duration(0).attr({x:l*(colind+8)});
    [highlightbox, hbnext] = [hbnext, highlightbox];
}

function nexthi16() {
    fade(maskbox, 0, 800, 0);
    fade(maskbox.transition().delay(810).duration(0).attr({x: y=>l*(colind+(m*y)%8)}),
                  880, 800, 1);
}

function end() {
    fade(highlightbox, 0, 300, 0);
    fade(maskback,     0, 400, 1);
}


var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0: addboundary(); break;
        case 1: align(); break;
        case 2: wrap(); break;
        case 3: highlight(); break;
        case 4: dealign(); break;
        case 5: transpose(); break;
        case 6: back(); break;
        case 7: case 8: case 9: nextcol(); break;

        case 10: back2(); break;
        case 11: box16(); break;
        case 12: case 13: case 14: case 15: case 16: case 17:
            (step%2 ? nextcol16 : nexthi16)(); break;
        case 18: end(); break;
    }
}
